searchNodes=[{"doc":"ChromicPDF is a fast HTML-to-PDF/A renderer based on Chrome &amp; Ghostscript. Usage Start Start ChromicPDF as part of your supervision tree: def MyApp.Application do def start ( _type , _args ) do children = [ # other apps... { ChromicPDF , chromic_pdf_opts ( ) } ] Supervisor . start_link ( children , strategy : :one_for_one , name : MyApp.Supervisor ) end defp chromic_pdf_opts do [ ] end end Print a PDF ChromicPDF . print_to_pdf ( { :file , &quot;example.html&quot; } , output : &quot;output.pdf&quot; ) This tells Chrome to open the example.html file from your current directory and save the rendered page as output.pdf . PDF printing comes with a ton of options. Please see ChromicPDF.print_to_pdf/2 for details. Print a PDF/A ChromicPDF . print_to_pdfa ( { :file , &quot;example.html&quot; } , output : &quot;output.pdf&quot; ) This prints the same PDF with Chrome and afterwards passes it to Ghostscript to convert it to a PDF/A. Please see ChromicPDF.print_to_pdfa/2 or ChromicPDF.convert_to_pdfa/2 for details. Security considerations By default, ChromicPDF will allow Chrome to make use of its own &quot;sandbox&quot; process jail . The sandbox tries to limit system resource access of the renderer processes to the minimum resources they require to perform their task. It is designed to make displaying HTML pages relatively safe, in terms of preventing undesired access of a page to the host operating system. Nevertheless, running a browser as part of your application, especially when used to process user-supplied content, significantly increases your attack surface. Hence, before adding ChromicPDF to your application's (perhaps already long) list of dependencies, you may want to consider the security hints below. Architectural isolation A great, if not the best option to mitigate security risks due to the use of ChromicPDF / a Browser in your stack, is to turn your &quot;document renderer&quot; component into a containerized service with a small RPC interface. This will create a nice barrier between Chrome and the rest of your application, so that even if an attacker manages to escape Chrome's sandbox, they will still be jailed within the container. It also has other benefits like better control of resources, e.g. how much CPU you want to dedicate to PDF rendering. Escape user-supplied data Make sure to always escape user-provided data with something like Phoenix.HTML.html_escape . This should prevent an attacker from injecting malicious scripts into your template. Disabling scripts If your template allows, you can disable JavaScript execution altogether (using the DevTools command Emulation.setScriptExecutionDisabled ) with the :disable_scripts option: def chromic_pdf_opts do [ disable_scripts : true ] end Note that this doesn't prevent other features like the evaluate option from working, it solely applies to scripts being supplied by the rendered page itself. Running in offline mode To prevent your templates from accessing any remote hosts, the browser targets can be spawned in &quot;offline mode&quot; (using the DevTools command Network.emulateNetworkConditions ). Chrome targets with network conditions set to offline can't resolve any external URLs (e.g. https:// ), neither entered as navigation URL nor contained within the HTML body. def chromic_pdf_opts do [ offline : true ] end Chrome Sandbox in Docker containers In Docker containers running Linux images (e.g. images based on Alpine), and which are configured to run their main job as a non-root user, the sandbox may cause Chrome to crash on startup as it requires root privileges. The error output ( discard_stderr: false option) looks as follows: Failed to move to new namespace : PID namespaces supported , Network namespace supported , but failed : errno = Operation not permitted The best way to resolve this issue is to configure your Docker container to use seccomp rules that grant Chrome access to the relevant system calls. See the excellent Zenika/alpine-chrome repository for details on how to make this work. Alternatively, you may choose to disable Chrome's sandbox with the no_sandbox option. defp chromic_pdf_opts do [ no_sandbox : true ] end Only local Chrome instances This option is available only for local Chrome instances. SSL connections In you are fetching your print source from a https:// URL, as usual Chrome verifies the remote host's SSL certificate when establishing the secure connection, and errors out of navigation if the certificate has expired or is not signed by a known certificate authority (i.e. no self-signed certificates). For production systems, this security check is essential and should not be circumvented. However, if for some reason you need to bypass certificate verification in development or test, you can do this with the :ignore_certificate_errors option. defp chromic_pdf_opts do [ ignore_certificate_errors : true ] end Session pool ChromicPDF spawns a pool of targets (= tabs) inside the launched Chrome process. These are held in memory to reduce initialization time in the PDF print jobs. Operation timeouts By default, ChromicPDF allows the print process to take 5 seconds to finish. In case you are printing large PDFs and run into timeouts, these can be configured configured by passing the timeout option to the session pool. defp chromic_pdf_opts do [ session_pool : [ timeout : 10_000 ] # in milliseconds ] end Concurrency ChromicPDF depends on the NimblePool library to manage the browser sessions in a pool. To increase or limit the number of concurrent sessions, you can pass pool configuration to the supervisor. defp chromic_pdf_opts do [ session_pool : [ size : 3 ] ] end NimblePool performs simple queueing of operations. The maximum time an operation is allowed to wait in the queue is configurable with the :checkout_timeout option, and defaults to 5 seconds. defp chromic_pdf_opts do [ session_pool : [ checkout_timeout : 5_000 ] ] end Please note that this is not a persistent queue. If your concurrent demand exceeds the configured concurrency, your jobs will begin to time out. In this case, an asynchronous approach backed by a persistent job processor like Oban will give you better results, and likely improve your application's UX. Automatic session restarts to avoid memory drain By default, ChromicPDF will restart sessions within the Chrome process after 1000 operations. This helps to prevent infinite growth in Chrome's memory consumption. The &quot;max age&quot; of a session can be configured with the :max_uses option. defp chromic_pdf_opts do [ session_pool : [ max_uses : 1000 ] ] end Multiple session pools ChromicPDF supports running multiple named session pools to allow varying session configuration. For example, this makes it possible to have one pool that is not allowed to execute JavaScript while others can use JavaScript. defp chromic_pdf_opts do [ session_pool : %{ with_scripts : [ ] , without_scripts : [ disabled_scripts : true ] } ] end When you define multiple session pools, you need to assign the pool to use in each PDF job: ChromicPDF . print_to_pdf ( ... , session_pool : :without_scripts ) Global options are used as defaults for each configured pool. See ChromicPDF.session_option/0 for a list of options for the session pools. Chrome zombies Help, a Chrome army tries to take over my system! ChromicPDF tries its best to gracefully close the external Chrome process when its supervisor is terminated. Unfortunately, when the BEAM is not shutdown gracefully, Chrome processes will keep running. While in a containerized production environment this is unlikely to be of concern, in development it can lead to unpleasant performance degradation of your operation system. In particular, the BEAM is not shutdown properly… when you exit your application or iex console with the Ctrl+C abort mechanism (see issue #56 ), and when you run your tests. No, after an ExUnit run your application's supervisor is not terminated cleanly. There are a few ways to mitigate this issue. &quot;On Demand&quot; mode In case you habitually end your development server with Ctrl+C, you should consider enabling &quot;On Demand&quot; mode which disables the session pool, and instead starts and stops Chrome instances as needed. If multiple PDF operations are requested simultaneously, multiple Chrome processes will be launched (each with a pool size of 1, disregarding the pool configuration). defp chromic_pdf_opts do [ on_demand : true ] end To enable it only for development, you can load the option from the application environment. # config/config.exs config :my_app , ChromicPDF , on_demand : false # config/dev.exs config :my_app , ChromicPDF , on_demand : true # application.ex @chromic_pdf_opts Application . compile_env! ( :my_app , ChromicPDF ) defp chromic_pdf_opts do @chromic_pdf_opts ++ [ ... other opts ... ] end Terminating your supervisor after your test suite You can enable &quot;On Demand&quot; mode for your tests, as well. However, please be aware that each test that prints a PDF will have an increased runtime (plus about 0.5s) due to the added Chrome boot time cost. Luckily, ExUnit provides a method to run code at the end of your test suite. # test/test_helper.exs ExUnit . after_suite ( fn _ -&gt; Supervisor . stop ( MyApp.Supervisor ) end ) ExUnit . start ( ) Only start ChromicPDF in production The easiest way to prevent Chrome from spawning in development is to only run ChromicPDF in the prod environment. However, obviously you won't be able to print PDFs in development or test then. Chrome options By default, ChromicPDF will try to run a Chrome instance in the local environment. The following options allow to customize the generated command line. Custom command line switches The :chrome_args option allows to pass arbitrary options to the Chrome/Chromium executable. defp chromic_pdf_opts do [ chrome_args : &quot;--font-render-hinting=none&quot; ] end In some cases, ChromicPDF's default arguments (e.g. --disable-gpu ) may conflict with the ones you would like to add. In this case, use can supply a keyword list to the :chrome_args option which allows targeted removing of default arguments. defp chromic_pdf_opts do [ chrome_args : [ append : &quot;--headless=new --angle=swiftshader&quot; , remove : [ &quot;--headless&quot; , &quot;--disable-gpu&quot; ] ] ] end The :chrome_executable option allows to specify a custom Chrome/Chromium executable. defp chromic_pdf_opts do [ chrome_executable : &quot;/usr/bin/google-chrome-beta&quot; ] end Font rendering issues on Linux On Linux, Chrome and its rendering engine Skia have longstanding issues with rendering certain fonts for print media, especially with regards to letter kerning. See this issue in puppeteer for a discussion. If your documents suffer from incorrectly spaced letters, you can try some of the following: Apply the text-rendering: geometricPrecision CSS rule. In our tests, this has shown to be the most reliable option. Besides, it is also the most flexible option as you can apply it to individual elements depending on the font-face they use. Recommended. Set --font-render-hinting=none or --disable-font-subpixel-positioning command line switches (see :chrome_args option above). While this generally improved text rendering in all our tests, it is a bit of a mallet method. See also this blog post for more hints. Debugging Chrome errors Chrome's stderr logging is silently discarded to not obscure your logfiles. In case you would like to take a peek, add the discard_stderr: false option. defp chromic_pdf_opts do [ discard_stderr : false ] end Remote Chrome Instead of running a local Chrome instance, you may connect to an external Chrome instance via its websocket-based debugging interface. For example, you can run a headless Chrome inside a docker container using the minimalistic Zenika/alpine-chrome images: $ docker run --rm -p 9222:9222 \\ zenika/alpine-chrome:114 \\ --no-sandbox \\ --headless \\ --remote-debugging-port=9222 \\ --remote-debugging-address=0.0.0.0 See the ChromicPDF.ChromeRunner module for a list of command line arguments that may improve your headless Chrome experience. To enable remote connections to Chrome, you need to specify the hostname and port of the running Chrome instance using the :chrome_address option. Setting this option will disable the command line-related options discussed above. defp chromic_pdf_opts do [ chrome_address : { &quot;localhost&quot; , 9222 } ] end To communicate with Chrome through its the websocket interface, ChromicPDF has an optional dependency on the websockex package, which you need to explicitly add to your mix.exs : def deps do [ { :chromic_pdf , &quot;...&quot; } , { :websockex , &quot;~&gt; 0.4.3&quot; } ] end In case you have added websockex after chromic_pdf had already been compiled, you need to force a recompilation with mix deps.compile --force chromic_pdf . Experimental Please note that support for remote connections is considered experimental. Be aware that between restarts ChromicPDF may leave tabs behind and your external Chrome process may leak memory. Ghostscript pool In addition to the session pool, a pool of ghostscript &quot;executors&quot; is started, in order to limit this resource as well. By default, ChromicPDF allows the same number of concurrent Ghostscript processes to run as it spawns sessions in Chrome itself. defp chromic_pdf_opts do [ ghostscript_pool : [ size : 10 ] ] end Telemetry support To provide insights into PDF and PDF/A generation performance, ChromicPDF executes the following telemetry events: [:chromic_pdf, :print_to_pdf, :start | :stop | exception] [:chromic_pdf, :capture_screenshot, :start | :stop | :exception] [:chromic_pdf, :convert_to_pdfa, :start | :stop | exception] Please see :telemetry.span/3 for details on their payloads, and :telemetry.attach/4 for how to attach to them. Each of the corresponding functions accepts a telemetry_metadata option which is passed to the attached event handler. This can, for instance, be used to mark events with custom tags such as the type of the print document. ChromicPDF . print_to_pdf ( ... , telemetry_metadata : %{ template : &quot;invoice&quot; } ) The print_to_pdfa/2 function emits both the print_to_pdf and convert_to_pdfa event series, in that order. Last but not least, the print_to_pdf/2 function emits :join_pdfs events when concatenating multiple input sources. [:chromic_pdf, :join_pdfs, :start | :stop | exception] Further options Debugging JavaScript errors &amp; warnings By default, unhandled runtime exceptions thrown in JavaScript execution contexts are logged. You may choose to instead convert them into an Elixir exception by passing the following option: defp chromic_pdf_opts do # :ignore | :log (default) | :raise [ unhandled_runtime_exceptions : :raise ] end Alternatively, you can pass :ignore to silence the log statement. Calls to console.log &amp; friends are ignored by default, and can be configured to be logged like this: defp chromic_pdf_opts do # :ignore (default) | :log | :raise [ console_api_calls : :log ] end On Accessibility / PDF/UA Since its version 85, Chrome generates &quot;Tagged PDF&quot; files by default . These files contain structural information about the document, i.e. type information about the nodes (headings, paragraph, etc.), as well as metadata like node attributes (e.g., image alt texts). This information allows assistive tools like screen readers to do their job, at the cost of (at times significantly) increasing the file size. To check whether a PDF file is tagged, you can use the pdfinfo utility, it reports these files as Tagged: yes . You can review some of the contained information with the pdfinfo -struct-text &lt;file&gt; command. Tagging may be disabled by passing the --disable-pdf-tagging argument to Chrome via the chrome_args option. However, at the time of writing, Chrome's most recent beta version 109 does not generate files compliant to the PDF/UA standard (ISO 14289-1:2014). Both the &quot;PAC 2021&quot; accessibility checker and the VeraPDF validator (capable of validating a subset of the PDF/UA rules since version 1.18 from April 2021 ) report rule violations concerning mandatory metadata. So, if your use-case requires you to generate fully PDF/UA-compliant files, at the moment Chrome (and by extension, ChromicPDF) is not going fulfill your needs. Furthermore, any operation that involves running the Chrome-generated file through Ghostscript (PDF/A conversion, concatenation) will remove all structural information , so that pdfinfo reports Tagged: no , and thereby prevent assistive tools from proper functioning.","ref":"ChromicPDF.html","title":"ChromicPDF","type":"module"},{"doc":"Captures a screenshot. This call blocks until the screenshot has been created. Print and return Base64-encoded PNG { :ok , blob } = ChromicPDF . capture_screenshot ( { :url , &quot;file:///example.html&quot; } ) Custom options for Page.captureScreenshot Custom options for the Page.captureScreenshot call can be specified by passing a map to the :capture_screenshot option. ChromicPDF . capture_screenshot ( { :url , &quot;file:///example.html&quot; } , capture_screenshot : %{ format : &quot;jpeg&quot; } ) For navigational options (source, cookies, evaluating scripts) see print_to_pdf/2 . You may also use ChromicPDF.Template as an input source for capture_screenshot/2 , yet keep in mind that many of the page-related styles do not take effect for screenshots. Full page screenshots You can pass the :full_page option to make ChromicPDF increase the viewport dimensions to fit the entire content. This option only works with Chrome version 91 or greater. ChromicPDF . capture_screenshot ( { :url , &quot;file:///very-long-content.html&quot; } , full_page : true )","ref":"ChromicPDF.html#capture_screenshot/2","title":"ChromicPDF.capture_screenshot/2","type":"function"},{"doc":"Returns a specification to start this module as part of a supervision tree.","ref":"ChromicPDF.html#child_spec/1","title":"ChromicPDF.child_spec/1","type":"function"},{"doc":"Converts a PDF to PDF/A (either PDF/A-2b or PDF/A-3b). Convert an input PDF and return a Base64-encoded blob { :ok , blob } = ChromicPDF . convert_to_pdfa ( &quot;some_pdf_file.pdf&quot; ) Convert and write to file ChromicPDF . convert_to_pdfa ( &quot;some_pdf_file.pdf&quot; , output : &quot;output.pdf&quot; ) PDF/A versions &amp; levels Ghostscript supports both PDF/A-2 and PDF/A-3 versions, both in their b (basic) level. By default, ChromicPDF generates version PDF/A-3b files. Set the pdfa_version option for version 2. ChromicPDF . convert_to_pdfa ( &quot;some_pdf_file.pdf&quot; , pdfa_version : &quot;2&quot; ) Generated files pass the verapdf validation. When you verify this, please pass the corresponding profile arguments ( -f 2b or -f 3b ). Specifying PDF metadata The converter is able to transfer PDF metadata (the Info dictionary) from the original PDF file to the output file. However, files printed by Chrome do not contain any metadata information (except &quot;Creator&quot; being &quot;Chrome&quot;). The :info option of the PDF/A converter allows to specify metadata for the output file directly. ChromicPDF . convert_to_pdfa ( &quot;some_pdf_file.pdf&quot; , info : %{ creator : &quot;ChromicPDF&quot; } ) The converter understands the following keys, all of which accept String values: :title :author :subject :keywords :creator :creation_date :mod_date By specification, date values in :creation_date and :mod_date do not need to follow a specific syntax. However, Ghostscript inserts date strings like &quot;D:20200208153049+00'00'&quot; and Info extractor tools might rely on this or another specific format. The converter will automatically format given DateTime values like this. Both :creation_date and :mod_date are filled with the current date automatically (by Ghostscript), if the original file did not contain any. Adding more PostScript to the conversion The pdfa_def_ext option can be used to feed more PostScript code into the final conversion step. ChromicPDF . convert_to_pdfa ( &quot;some_pdf_file.pdf&quot; , pdfa_def_ext : &quot;[/Title (OverriddenTitle) /DOCINFO pdfmark&quot; , ) If your extra Postscript requires read permissions for additional files, pass the :permit_read option. ChromicPDF . convert_to_pdfa ( &quot;some_pdf_file.pdf&quot; , pdfa_def_ext : &quot;custom-postscript&quot; , permit_read : &quot;/some/path&quot; , permit_read : &quot;/some/other/path&quot; ) Embedded color scheme Since it is required to embed a color scheme into PDF/A files, ChromicPDF ships with a copy of the royalty-free eciRGB_V2 scheme by the European Color Initiative. If you need to to use a different color scheme, please open an issue. Accessibility Please note that running a PDF file through Ghostscript removes all structural annotations (&quot;Tags&quot;) and hence disables accessibility features of assistive technologies. See On Accessibility / PDF/UA section for details.","ref":"ChromicPDF.html#convert_to_pdfa/2","title":"ChromicPDF.convert_to_pdfa/2","type":"function"},{"doc":"Retrieves the currently set name (set using put_dynamic_name/1 ) or the default name.","ref":"ChromicPDF.html#get_dynamic_name/0","title":"ChromicPDF.get_dynamic_name/0","type":"function"},{"doc":"Prints a PDF. This call blocks until the PDF has been created. Output options Print and return Base64-encoded PDF { :ok , blob } = ChromicPDF . print_to_pdf ( { :url , &quot;file:///example.html&quot; } ) # Can be displayed in iframes &quot;data:application/pdf;base64, \\# {blob}&quot; Print to file :ok = ChromicPDF . print_to_pdf ( { :url , &quot;file:///example.html&quot; } , output : &quot;output.pdf&quot; ) Print to temporary file { :ok , :some_result } = ChromicPDF . print_to_pdf ( { :url , &quot;file:///example.html&quot; } , output : fn path -&gt; send_download ( path ) :some_result end ) The temporary file passed to the callback will be deleted when the callback returns. Input options You can choose between multiple methods of supplying Chrome with the HTML source to print: Printing from a URL Internal endpoint with request forwarding Injecting the HTML markup directly into the DOM through the remote debugging API Print from URL Passing in a URL is the simplest way of printing a PDF. A target in Chrome is told to navigate to the given URL. When navigation is finished, the PDF is printed. ChromicPDF . print_to_pdf ( { :url , &quot;file:///example.html&quot; } ) ChromicPDF . print_to_pdf ( { :url , &quot;http://example.net&quot; } ) ChromicPDF . print_to_pdf ( { :url , &quot;https://example.net&quot; } ) Printing from URL has the benefit of being the tried-and-true solution, as Chrome's content loading works just as you would expect, including its assets cache. Cookies If your URL requires authentication, you can pass in a session cookie. The cookie is automatically cleared after the PDF has been printed. cookie = %{ name : &quot;foo&quot; , value : &quot;bar&quot; , domain : &quot;localhost&quot; } ChromicPDF . print_to_pdf ( { :url , &quot;http:///example.net&quot; } , set_cookie : cookie ) See Network.setCookie for options. name and value keys are required. Internal endpoint with request forwarding Serving HTML templates from an internal endpoint allows you to leverage your existing HTTP server and HTML rendering infrastructure. Usually, you will want to render a HTML template from data you have in hand when calling print_to_pdf/2 . ChromicPDF.Plug allows you to pass a callback function from the caller to the process serving Chrome's HTTP request. ChromicPDF . print_to_pdf ( { :plug , url : &quot;http://localhost:4000/makepdf&quot; , forward : fn conn -&gt; # this is executed in the context of the incoming Chrome request end } ) You can also pass a {module, func, [postargs]} tuple to the :forward option. Print from in-memory HTML Alternatively, print_to_pdf/2 allows to pass an in-memory HTML blob to Chrome in a {:html, blob()} tuple. The HTML is sent to the target using the Page.setDocumentContent function. ChromicPDF . print_to_pdf ( { :html , &quot;&lt;h1&gt;Hello World!&lt;/h1&gt;&quot; } ) This method is useful for setups where Chrome has no network access to the application that hosts ChromicPDF, or you prefer not to have an HTTP server in your application. Caveats However, in-memory HTML printing comes with a few caveats. References to external files in HTML source Since the document content is replaced without navigating to a URL, Chrome has no way of telling which host it should contact to resolve relative URLs contained in the source. If your HTML contains markup like &lt;!-- BAD: relative link to stylesheet in &lt;head&gt; element --&gt; &lt;head&gt; &lt;link rel=&quot;stylesheet&quot; href=&quot;selfhtml.css&quot;&gt; &lt;/head&gt; &lt;!-- BAD: relative link to image --&gt; &lt;img src=&quot;some_logo.png&quot;&gt; ... you will need to replace these lines with either absolute URLs or inline data . Of course, absolute URLs can use the file:// scheme to point to files on the local filesystem, assuming Chrome has access to them. For the purpose of displaying small inline images (e.g. logos), data URLs are a good way of embedding them without the need for an absolute URL. &lt;!-- GOOD: inline styles --&gt; &lt;style&gt; /* ... */ &lt;/style&gt; &lt;!-- GOOD: data URLs --&gt; &lt;img src=&quot;data:image/png;base64,R0lGODdhEA...&quot;&gt; &lt;!-- GOOD: absolute URLs --&gt; &lt;img src=&quot;http://localhost/path/to/image.png&quot;&gt; &lt;img src=&quot;file:///path/to/image.png&quot;&gt; Content from Phoenix templates If your content is generated by a Phoenix template (and hence comes in the form of {:safe, iodata()} or %Phoenix.LiveView.Rendered{} ), you will need to pass it to Phoenix.HTML.safe_to_string/1 first. content = SomeView . render ( &quot;body.html&quot; ) |&gt; Phoenix.HTML . safe_to_string ( ) ChromicPDF . print_to_pdf ( { :html , content } ) Concatenating multiple sources Pass a list of sources as first argument to instruct ChromicPDF to create a PDF file for each source and concatenate these using Ghostscript. This is particularly useful when some sections of your final document require a different page layout than others. You may use ChromicPDF.Template or tuple sources. [ ChromicPDF.Template . source_and_options ( content : &quot;&lt;h1&gt;First part with header&lt;/h1&gt;&quot; , header_height : &quot;20mm&quot; , header : &quot;&lt;p&gt;Some header text&lt;/p&gt;&quot; ) , { :html , &quot;second part without header&quot; } ] |&gt; ChromicPDF . print_to_pdf ( ) You can pass additional options to print_to_pdf/2 as usual, e.g. :output to control the return value handling. Individual sources are processed sequentially and eventually concatenated, so expect runtime to increase linearly with the number of sources. The session timeout is applied per source. Each source emits the normal :print_to_pdf telemetry events. The final concatenation emits :join_pdfs events. Please note that running PDF files through Ghostscript removes all structural annotations (&quot;Tags&quot;) and hence disables accessibility features of assistive technologies. See On Accessibility / PDF/UA section for details. Custom options for Page.printToPDF You can provide custom options for the Page.printToPDF call by passing a map to the :print_to_pdf option. ChromicPDF . print_to_pdf ( { :url , &quot;file:///example.html&quot; } , print_to_pdf : %{ # Margins are in given inches marginTop : 0.393701 , marginLeft : 0.787402 , marginRight : 0.787402 , marginBottom : 1.1811 , # Print header and footer (on each page). # This will print the default templates if none are given. displayHeaderFooter : true , # Even on empty string. # To disable header or footer, pass an empty element. headerTemplate : &quot;&lt;span&gt;&lt;/span&gt;&quot; , # Example footer template. # They are completely unstyled by default and have a font-size of zero, # so don&#39;t despair if they don&#39;t show up at first. # There&#39;s a lot of documentation online about how to style them properly, # this is just a basic example. Also, take a look at the documentation for the # ChromicPDF.Template module. # The &lt;span&gt; classes shown below are interpolated by Chrome. footerTemplate : &quot;&quot;&quot; &lt;style&gt; p { color: #333; font-size: 10pt; text-align: right; margin: 0 0.787402in; width: 100%; z-index: 1000; } &lt;/style&gt; &lt;p&gt; Page &lt;span class=&quot;pageNumber&quot;&gt;&lt;/span&gt; of &lt;span class=&quot;totalPages&quot;&gt;&lt;/span&gt; &lt;/p&gt; &quot;&quot;&quot; } ) Please note the camel-case . For a full list of options, please see the Chrome documentation at: https://chromedevtools.github.io/devtools-protocol/tot/Page#method-printToPDF Page size and margins Chrome will use the provided pagerWidth and paperHeight dimensions as the PDF paper format. Please be aware that the @page section in the body CSS is not correctly interpreted, see ChromicPDF.Template for a discussion. Header and footer Chrome's support for native header and footer sections is a little bit finicky. Still, to the best of my knowledge, Chrome is currently the only well-functioning solution for HTML-to-PDF conversion if you need headers or footers that are repeated on multiple pages even in the presence of body elements stretching across a page break. In order to make header and footer visible in the first place, you will need to be aware of a couple of caveats: You can not use any external ( http:// or https:// ) resources in the header or footer, not even per absolute URL. You need to inline all your CSS and convert your images to data-URLs. Javascript is not interpreted either. HTML for header and footer is interpreted in a new page context which means no body styles will be applied. In fact, even default browser styles are not present, so all content will have a default font-size of zero, and so on. You need to make space for the header and footer templates first, by adding page margins. Margins can either be given using the marginTop and marginBottom options or with CSS styles. If you use the options, the height of header and footer elements will inherit these values. If you use CSS styles, make sure to set the height of the elements in CSS as well. Header and footer have a default padding to the page ends of 0.4 centimeters. To remove this, add the following to header/footer template styles (source) . #header, #footer { padding: 0 !important; } Header and footer have a default zoom level of 1/0.75 so everything appears to be smaller than in the body when the same styles are applied. If header or footer are not displayed even though they should, make sure your HTML is valid. Tuning the margins for an hour looking for mistakes there, only to discover that you are missing a closing &lt;/style&gt; tag, can be quite painful. Background colors are not applied unless you include -webkit-print-color-adjust: exact in your stylesheet. See print_header_footer_template.html from the Chromium sources to see how these values are interpreted. Dynamic Content Evaluate script before printing In case your print source is generated by client-side scripts, for instance to render graphics or load additional resources, you can trigger these by evaluating a JavaScript expression before the PDF is printed. evaluate = %{ expression : &quot;&quot;&quot; document.querySelector(&#39;body&#39;).innerHTML = &#39;hello world&#39;; &quot;&quot;&quot; } ChromicPDF . print_to_pdf ( { :url , &quot;http://example.net&quot; } , evaluate : evaluate ) If your script returns a Promise, Chrome will wait for it to be resolved. Wait for attribute on element Some JavaScript libraries signal their successful initialization to the user by setting an attribute on a DOM element. The wait_for option allows you to wait for this attribute to be set before printing. It evaluates a script that repeatedly queries the element given by the query selector and tests whether it has the given attribute. wait_for = %{ selector : &quot;#my-element&quot; , attribute : &quot;ready-to-print&quot; } ChromicPDF . print_to_pdf ( { :url , &quot;http:///example.net&quot; } , wait_for : wait_for )","ref":"ChromicPDF.html#print_to_pdf/2","title":"ChromicPDF.print_to_pdf/2","type":"function"},{"doc":"Prints a PDF and converts it to PDF/A in a single call. See print_to_pdf/2 and convert_to_pdfa/2 for options. Example ChromicPDF . print_to_pdfa ( { :url , &quot;https://example.net&quot; } )","ref":"ChromicPDF.html#print_to_pdfa/2","title":"ChromicPDF.print_to_pdfa/2","type":"function"},{"doc":"Activate a particular ChromicPDF instance, which was started with the name option. After calling this function, all calls in the current process will use this instance of ChromicPDF. You can use this function if you need to run ChromicPDF as part of a supervision tree with a particular name, for example: defmodule MySupervisor do use Supervisor @impl true def init ( opts ) do children = [ # other apps... { ChromicPDF , name : MyName } ] Supervisor . init ( children , strategy : :one_for_one , name : MyApp.Supervisor ) end end Returns the previously set name or the default name.","ref":"ChromicPDF.html#put_dynamic_name/1","title":"ChromicPDF.put_dynamic_name/1","type":"function"},{"doc":"Starts ChromicPDF. &quot;On Demand&quot; mode If the given config includes the on_demand: true flag, this will not spawn a Chrome instance but instead hold the configuration in an Agent until a PDF print job is triggered. The print job will launch a temporary browser process and perform a graceful shutdown at the end. Please note that the browser process is spawned from your client process and that these processes are linked. If your client process is trapping EXIT signals, you will receive a message when the browser is terminated.","ref":"ChromicPDF.html#start_link/1","title":"ChromicPDF.start_link/1","type":"function"},{"doc":"Runs a one-off Chrome process to allow Chrome to initialize its caches. On some infrastructure (notably, Github Actions), Chrome occasionally takes a long nap between process launch and first replying to DevTools commands. If meanwhile you happen to print a PDF (so, before any sessions have been spawned by the session pool), the session checkout will fail with a timeout error: Caught EXIT signal from NimblePool . checkout! / 4 ** (EXIT) time out This function mitigates the issue by launching a Chrome process via a shell command, bypassing ChromicPDF's internals. Usage # in your test_helper.exs { :ok , _ } = ChromicPDF . warm_up ( ) ... ExUnit . start ( ) Options This function accepts all options of print_to_pdf/2 related to external Chrome process. If you pass discard_stderr: false , Chrome's standard error is returned. { :ok , stderr } = ChromicPDF . warm_up ( discard_stderr : false ) IO . inspect ( stderr , label : &quot;chrome stderr&quot; ) Mix Task Alternatively, you can choose to run a mix task as part of your CI script, see Mix.Tasks.ChromicPdf.WarmUp . The task currently does not accept any options. ... $ mix chromic_pdf . warm_up $ mix test","ref":"ChromicPDF.html#warm_up/1","title":"ChromicPDF.warm_up/1","type":"function"},{"doc":"","ref":"ChromicPDF.html#t:capture_screenshot_option/0","title":"ChromicPDF.capture_screenshot_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:deprecated_max_session_uses_option/0","title":"ChromicPDF.deprecated_max_session_uses_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:evaluate_option/0","title":"ChromicPDF.evaluate_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:export_option/0","title":"ChromicPDF.export_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:export_return/0","title":"ChromicPDF.export_return/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:extended_chrome_args/0","title":"ChromicPDF.extended_chrome_args/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:ghostscript_pool_option/0","title":"ChromicPDF.ghostscript_pool_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:global_option/0","title":"ChromicPDF.global_option/0","type":"type"},{"doc":"These options apply to remote Chrome instances only.","ref":"ChromicPDF.html#t:inet_chrome_option/0","title":"ChromicPDF.inet_chrome_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:info_option/0","title":"ChromicPDF.info_option/0","type":"type"},{"doc":"These options apply to local Chrome instances only.","ref":"ChromicPDF.html#t:local_chrome_option/0","title":"ChromicPDF.local_chrome_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:named_session_pools/0","title":"ChromicPDF.named_session_pools/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:navigate_option/0","title":"ChromicPDF.navigate_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:output_function/0","title":"ChromicPDF.output_function/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:output_function_result/0","title":"ChromicPDF.output_function_result/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:output_option/0","title":"ChromicPDF.output_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:path/0","title":"ChromicPDF.path/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:pdf_option/0","title":"ChromicPDF.pdf_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:pdfa_option/0","title":"ChromicPDF.pdfa_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:plug_forward/0","title":"ChromicPDF.plug_forward/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:plug_option/0","title":"ChromicPDF.plug_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:session_option/0","title":"ChromicPDF.session_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:session_pool_option/0","title":"ChromicPDF.session_pool_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:source/0","title":"ChromicPDF.source/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:source_and_options/0","title":"ChromicPDF.source_and_options/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:source_tuple/0","title":"ChromicPDF.source_tuple/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:telemetry_metadata_option/0","title":"ChromicPDF.telemetry_metadata_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:url/0","title":"ChromicPDF.url/0","type":"type"},{"doc":"","ref":"ChromicPDF.html#t:wait_for_option/0","title":"ChromicPDF.wait_for_option/0","type":"type"},{"doc":"This module implements a &quot;request forwarding&quot; mechanism from an internal endpoint serving incoming requests by Chrome to the print_to_pdf/2 caller process. Usage In your router: forward &quot;/makepdf&quot; , ChromicPDF.Plug On the caller side: ChromicPDF . print_to_pdf ( { :plug , url : &quot;http://localhost:4000/makepdf&quot; , forward : { MyTemplate , :render , [ %{ hello : :world } ] } ) defmodule MyTemplate do def render ( conn , assigns ) do # send response via conn (and return conn) or return content to be sent by the plug end end","ref":"ChromicPDF.Plug.html","title":"ChromicPDF.Plug","type":"module"},{"doc":"Use this for multiple ChromicPDF instances. When is this useful? You want to completely separate two or more PDF worker pools You want to give your PDF module a custom API Usage defmodule MyApp.MyPDFGenerator do use ChromicPDF.Supervisor end def MyApp.Application do def start ( _type , _args ) do children = [ MyApp.MyPDFGenerator ] Supervisor . start_link ( children , strategy : :one_for_one , name : MyApp.Supervisor ) end end","ref":"ChromicPDF.Supervisor.html","title":"ChromicPDF.Supervisor","type":"module"},{"doc":"","ref":"ChromicPDF.Supervisor.html#child_spec/1","title":"ChromicPDF.Supervisor.child_spec/1","type":"function"},{"doc":"Fetches pids of the supervisor's services and passes them to the given callback function. If ChromicPDF has been configured to run in on_demand mode, this will start a temporary browser instance.","ref":"ChromicPDF.Supervisor.html#with_services/2","title":"ChromicPDF.Supervisor.with_services/2","type":"function"},{"doc":"","ref":"ChromicPDF.Supervisor.html#t:services/0","title":"ChromicPDF.Supervisor.services/0","type":"type"},{"doc":"Helper functions for page styling. For a start, see source_and_options/1 . Motivation This module contains helper functions that make it easier to to build HTML templates (body, header, and footer) that fully cover a given page. It tries to harmonize Chrome's printToPDF options and related CSS layout styles ( @page and friends) with a custom set of page sizing options. Using this module is entirely optional, but perhaps can help to avoid some common pitfalls arising from the slightly unintuitive and sometimes conflicting behaviour of printToPDF options and @page CSS styles in Chrome.","ref":"ChromicPDF.Template.html","title":"ChromicPDF.Template","type":"module"},{"doc":"Renders header/footer styles for given template options. These styles apply sane default to your header and footer templates. They set a default fonts-size and force their height. For Chromium before v120, they also set the zoom level of header and footer templates to 0.75 which aligns them with the content viewport scaling. https://bugs.chromium.org/p/chromium/issues/detail?id=1509917#c3","ref":"ChromicPDF.Template.html#header_footer_styles/1","title":"ChromicPDF.Template.header_footer_styles/1","type":"function"},{"doc":"Concatenes two HTML strings or iolists into one. From {:safe, iolist} tuples, the :safe is dropped. This is useful to prepare data coming from a Phoenix-compiled .eex template. content = html_concat ( @styles , render ( &quot;content.html&quot; ) )","ref":"ChromicPDF.Template.html#html_concat/2","title":"ChromicPDF.Template.html_concat/2","type":"function"},{"doc":"Returns an options list for given template options. Returned options can be passed as second argument to ChromicPDF.print_to_pdf/2 . Options header iodata content of header footer iodata content of footer all options from styles/1 Example This example has the dimension of a ISO A4 page. ChromicPDF.Template . options ( header : &quot;&lt;p&gt;header&lt;/p&gt;&quot; , footer : &quot;&lt;p&gt;footer&lt;/p&gt;&quot; , size : :a4 , header_height : &quot;45mm&quot; , header_font_size : &quot;20pt&quot; , footer_height : &quot;40mm&quot; ) Header, and footer templates should be unwrapped HTML markup (i.e. no &lt;html&gt; around the content), including any &lt;style&gt; tags that your page needs.","ref":"ChromicPDF.Template.html#options/1","title":"ChromicPDF.Template.options/1","type":"function"},{"doc":"Renders page styles for given template options. These base styles will configure page dimensions and apply margins for headers and footers. They also remove any default browser margin from the body, and apply sane defaults for rendering text in print. Options size page size, either a standard name ( :a4 , :us_letter ) or a {&lt;width&gt;, &lt;height&gt;} tuple in inches, default: :us_letter header_height default: zero header_font_size default: 10pt header_zoom default: 0.75 footer_height default: zero footer_font_size default: 10pt footer_zoom default: 0.75 webkit_color_print_adjust default: &quot;exact&quot; landscape default: false Landscape As it turns out, Chrome does not recognize the landscape option in its printToPDF command when explicit page dimensions are given. Hence, we provide a landscape option here that swaps the page dimensions (e.g. it turns 11.7x8.3&quot; A4 into 8.3&quot;x11.7&quot;).","ref":"ChromicPDF.Template.html#page_styles/1","title":"ChromicPDF.Template.page_styles/1","type":"function"},{"doc":"Returns source and options for a PDF to be printed, a given set of template options. The return value can be directly passed to ChromicPDF.print_to_pdf/2 . Options content iodata page content (required) header iodata content of header (default: &quot;&quot;) footer iodata content of footer (default: &quot;&quot;) all options from styles/1 Example This example has the dimension of a ISO A4 page. [ content : &quot;&lt;p&gt;Hello&lt;/p&gt;&quot; , header : &quot;&lt;p&gt;header&lt;/p&gt;&quot; , footer : &quot;&lt;p&gt;footer&lt;/p&gt;&quot; , size : :a4 , header_height : &quot;45mm&quot; , header_font_size : &quot;20pt&quot; , footer_height : &quot;40mm&quot; ] |&gt; ChromicPDF.Template . source_and_options ( ) |&gt; ChromicPDF . print_to_pdf ( ) Content, header, and footer templates should be unwrapped HTML markup (i.e. no &lt;html&gt; around the content), including any &lt;style&gt; tags that your page needs. &lt; style &gt; h1 { font - size : 22 pt ; } &lt; / style &gt; &lt; h1 &gt; Hello &lt; / h1 &gt; ⚠ Markup is injected into the DOM ⚠ Please be aware that the &quot;source&quot; returned by this function cause ChromicPDF to inject the markup directly into the DOM using the remote debugging API. This comes with some pitfalls which are explained in ChromicPDF.print_to_pdf/2 . Most notably, no relative URLs may be used within the given HTML.","ref":"ChromicPDF.Template.html#source_and_options/1","title":"ChromicPDF.Template.source_and_options/1","type":"function"},{"doc":"Renders page styles &amp; header/footer styles in a single template. This function is deprecated. Since Chromium v117 the footer and header templates must not contain any margins in a @page directive anymore. See https://github.com/bitcrowd/chromic_pdf/issues/290 for details. Please use page_styles/1 or header_footer_styles/1 instead.","ref":"ChromicPDF.Template.html#styles/1","title":"ChromicPDF.Template.styles/1","type":"function"},{"doc":"","ref":"ChromicPDF.Template.html#t:content_option/0","title":"ChromicPDF.Template.content_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.Template.html#t:header_footer_option/0","title":"ChromicPDF.Template.header_footer_option/0","type":"type"},{"doc":"","ref":"ChromicPDF.Template.html#t:paper_size/0","title":"ChromicPDF.Template.paper_size/0","type":"type"},{"doc":"","ref":"ChromicPDF.Template.html#t:style_option/0","title":"ChromicPDF.Template.style_option/0","type":"type"},{"doc":"Runs a one-off Chrome process to allow Chrome to initialize its caches. This function mitigates timeout errors on certain CI environments where Chrome would occasionally take a long time to respond to the first DevTools commands. See ChromicPDF.warm_up/1 for details.","ref":"Mix.Tasks.ChromicPdf.WarmUp.html","title":"Mix.Tasks.ChromicPdf.WarmUp","type":"task"},{"doc":"Exception in interaction with the session pool.","ref":"ChromicPDF.Browser.ExecutionError.html","title":"ChromicPDF.Browser.ExecutionError","type":"exception"},{"doc":"Exception in the communication with Chrome.","ref":"ChromicPDF.ChromeError.html","title":"ChromicPDF.ChromeError","type":"exception"},{"doc":"Exception raised when Chrome process has stopped unexpectedly.","ref":"ChromicPDF.Connection.ConnectionLostError.html","title":"ChromicPDF.Connection.ConnectionLostError","type":"exception"},{"doc":"ChromicPDF is a HTML-to-PDF renderer for Elixir, based on headless Chrome.","ref":"readme.html","title":"Read Me","type":"extras"},{"doc":"Node-free : In contrast to many other packages, it does not use puppeteer , and hence does not require Node.js. It communicates directly with Chrome's DevTools API over pipes, offering the same performance as puppeteer, if not better. Header/Footer : Using the DevTools API allows to apply the full set of options of the printToPDF function. Most notably, it supports header and footer HTML templates. PDF/A : It can convert printed files to PDF/A using Ghostscript. Converted files pass the verapdf validator.","ref":"readme.html#features","title":"Read Me - Features","type":"extras"},{"doc":"Chromium or Chrome Ghostscript (optional, for PDF/A support and concatenation of multiple sources) ChromicPDF is tested in the following configurations: Elixir Erlang/OTP Distribution Chromium Ghostscript 1.15.7 26.2 Alpine 3.18 119.0.6045.159 10.02.0 1.14.5 25.3.1 Alpine 3.17 112.0.5615.165 10.01.1 1.14.0 25.1 Debian Buster 90.0.4430.212-1 9.27 1.11.4 22.3.4.26 Debian Buster 90.0.4430.212-1 9.27","ref":"readme.html#requirements","title":"Read Me - Requirements","type":"extras"},{"doc":"ChromicPDF is a supervision tree (rather than an application). You will need to inject it into the supervision tree of your application. First, add ChromicPDF to your runtime dependencies: def deps do [ { :chromic_pdf , &quot;~&gt; 1.16&quot; } ] end Next, start ChromicPDF as part of your application: # lib/my_app/application.ex def MyApp.Application do def start ( _type , _args ) do children = [ # other apps... ChromicPDF ] Supervisor . start_link ( children , strategy : :one_for_one , name : MyApp.Supervisor ) end end","ref":"readme.html#installation","title":"Read Me - Installation","type":"extras"},{"doc":"Main API Here's how you generate a PDF from an external URL and store it in the local filesystem. # Prints a local HTML file to PDF. ChromicPDF . print_to_pdf ( { :url , &quot;https://example.net&quot; } , output : &quot;example.pdf&quot; ) The next example shows how to print a local HTML file to PDF/A, as well as the use of a callback function that receives the generated PDF as path to a temporary file. ChromicPDF . print_to_pdfa ( { :url , &quot;file:///example.html&quot; } , output : fn pdf -&gt; # Send pdf via mail, upload to S3, ... end ) Template API ChromicPDF.Template contains additional functionality for controlling page dimensions of your PDF. [ content : &quot;&lt;p&gt;Hello Template&lt;/p&gt;&quot; , size : :a4 ] |&gt; ChromicPDF.Template . source_and_options ( ) |&gt; ChromicPDF . print_to_pdf ( ) Multiple sources Multiple sources can be automatically concatenated using Ghostscript. ChromicPDF . print_to_pdf ( [ { :html , &quot;page 1&quot; } , { :html , &quot;page 2&quot; } ] , output : &quot;joined.pdf&quot; ) Examples There is an outdated example of how to integrate ChromicPDF in a Phoenix application, see examples/phoenix .","ref":"readme.html#usage","title":"Read Me - Usage","type":"extras"},{"doc":"This should get you started: mix deps . get mix test For running the full suite of integration tests, please install and have in your $PATH : verapdf For pdfinfo and pdftotext , you need poppler-utils (most Linux distributions) or Xpdf (OSX) For the odd ZUGFeRD test in zugferd_test.exs , you need to download ZUV and set the $ZUV_JAR environment variable.","ref":"readme.html#development","title":"Read Me - Development","type":"extras"},{"doc":"The PDF/A conversion is inspired by the pdf2archive script originally created by @matteosecli and later enhanced by @JaimeChavarriaga .","ref":"readme.html#acknowledgements","title":"Read Me - Acknowledgements","type":"extras"},{"doc":"Copyright (c) 2019–2023 Bitcrowd GmbH Licensed under the Apache License 2.0. See LICENSE file for details.","ref":"readme.html#copyright-and-license","title":"Read Me - Copyright and License","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Added Extend chrome_args to allow removal of conflicting default args. Allows for use cases which were previously blocked by defaults such as rendering WebGL images. See #314 (@walter)","ref":"changelog.html#1-16-1-2024-07-25","title":"Changelog - [1.16.1] - 2024-07-25","type":"extras"},{"doc":"Changed Removed the -dCompatibilityLevel=1.4 default switch from the ghostscript processor. Ghostscript has defaulted to to 1.7 for a long time now and we have been keeping this flag since GS 9.xx which likely not many people are using anymore. If anyone needs it, a new :compatibility_level option can used to set it back to 1.4.","ref":"changelog.html#1-16-0-2024-06-25","title":"Changelog - [1.16.0] - 2024-06-25","type":"extras"},{"doc":"Changed Expand phoenix_html dependency to include version 4 (@idabmat)","ref":"changelog.html#1-15-2-2024-01-04","title":"Changelog - [1.15.2] - 2024-01-04","type":"extras"},{"doc":"Fixed Explicitly pick keys in ChromicPDF.Template to fix Dialyzer &quot;no local return&quot; errors in clients.","ref":"changelog.html#1-15-1-2023-12-18","title":"Changelog - [1.15.1] - 2023-12-18","type":"extras"},{"doc":"Fixed Recover missing custom footer templates by making sure we do not add any @page CSS rule to the header or footer templates in ChromicPDF.Template.source_and_options/1 . (#290) Drop the default zoom: 0.75 rule from header and footer templates for Chrome &gt;= v120. They removed the default scale-up by 4/3, see chromium bug #1509917 . Note that for remote chrome users this means they will have to explicitly specify the chrome version in the application config. config :chromic_pdf , chrome_version : &quot;Google Chrome 120.0.6099.71&quot; Added Add ChromicPDF.Plug to forward Chrome requests on an internal endpoint to a template. Add Template.options/1 that returns the options for page dimensions, header, and footer, but does not require the content. Changed Drop -dNEWPDF=false switch from Ghostscript &gt;= 10.2. The old PDF interpreter has been removed and using the switch results in a warning now. Split Chromic.Template.styles/1 into page_styles/1 and header_footer_styles/1 , and trim the stylesheets. Cookies set via :set_cookie are now httpOnly: true by default. Removed Dropped the outdated Phoenix example in examples/ . Deprecated ChromicPDF.styles/1 .","ref":"changelog.html#1-15-0-2023-12-15","title":"Changelog - [1.15.0] - 2023-12-15","type":"extras"},{"doc":"Added Configurable pool checkout timeout via new global option :checkout_timeout .","ref":"changelog.html#1-14-0-2023-09-27","title":"Changelog - [1.14.0] - 2023-09-27","type":"extras"},{"doc":"Added Add support for named session pools . These can be used to give persistent session options ( offline , disable_scripts , ...) different values, for example to have one template that is not allowed to execute JavaScript and while others can use JavaScript. Changed Deprecate :max_session_uses option in favor of session_pool: [max_uses: ...] . Drop --no-zygote command line switch when using no_sandbox: true option. The switch causes session crashes in recent Chrome versions and was never needed for --no-sandbox in the first place. See #270. ⚠️ In case you are using no_sandbox: true , dropping --no-zygote means Chrome will spawn an additional OS process (the &quot;zygote&quot; process), which could be considered a break of backwards compatibility. Please monitor your next deployment. However, we believe this change is safe, meaning except for the additional process, it will not be noticable. Hence we concluded to drop the switch without a major version bump, in order not to disturb too many people. If you are not using :no_sandbox , this does not affect you.","ref":"changelog.html#1-13-0-2023-08-17","title":"Changelog - [1.13.0] - 2023-08-17","type":"extras"},{"doc":"Added Add :console_api_calls option to configure handling of console.foo calls in JS runtime (ignore, log, raise). Document fixes for font rendering issues, and give ChromicPDF.Template a text_rendering option to allow applying text-rendering: geometricPrecision; on all elements.","ref":"changelog.html#1-12-0-2023-07-12","title":"Changelog - [1.12.0] - 2023-07-12","type":"extras"},{"doc":"Added Add experimental support for connecting to running chrome instances via inet-based debugging (usually on port 9222). Controlled by option :chrome_address . Requires optional websockex dependency. Fixed Add --hide-scrollbars to default command line options, to hide scrollbars on screenshots.","ref":"changelog.html#1-11-0-2023-06-19","title":"Changelog - [1.11.0] - 2023-06-19","type":"extras"},{"doc":"Added Add :full_page option to ChromicPDF.capture_screenshot/2 to increase the viewport size to match the content.","ref":"changelog.html#1-10-0-2023-06-09","title":"Changelog - [1.10.0] - 2023-06-09","type":"extras"},{"doc":"Fixed Handle ChromicPDF.Template.source_and_options/1 tuples in ChromicPDF.capture_screenshot/2 .","ref":"changelog.html#1-9-1-2023-06-08","title":"Changelog - [1.9.1] - 2023-06-08","type":"extras"},{"doc":"Added Error handling for call responses in protocol steps, e.g. invalid options for printToPDF. (@tonnenpinguin)","ref":"changelog.html#1-9-0-2023-05-02","title":"Changelog - [1.9.0] - 2023-05-02","type":"extras"},{"doc":"Allow nimble_pool 1.0.","ref":"changelog.html#1-8-1-2023-04-20","title":"Changelog - [1.8.1] - 2023-04-20","type":"extras"},{"doc":"Added Add unhandled_runtime_exceptions option that allows to raise on unhandled JavaScript exceptions in templates. Default to warn about them in log. Changed Simplified on_demand mode. Instead of spawning the entire supervision tree temporarily, we now only spawn the Browser process. Also instead of giving the normal ChromicPDF name to the temporary supervisor, which effectively prevented concurrent access to ChromicPDF when configured with on_demand: true , the temporary Browser process remains anonymous.","ref":"changelog.html#1-8-0-2023-04-04","title":"Changelog - [1.8.0] - 2023-04-04","type":"extras"},{"doc":"Added Add ChromicPDF.put_dynamic_name/1 and name option to ChromicPDF.Supervisor.start_link/2 for dynamic process names. (@dvic) Fixed Handle DOWN reason in SessionPool.terminate_worker/3 callback. Fixes #219 .","ref":"changelog.html#1-7-0-2023-02-17","title":"Changelog - [1.7.0] - 2023-02-17","type":"extras"},{"doc":"Fixed Filename quoting (like -sOutputFile=&quot;/some/path&quot; ) doesn't work anymore in GS 9.56+. Dropped as we didn't need it anyway. GS 9.56 and 10.0 are supported now. Added Add permit_read option to convert_to_pdfa/2 and print_to_pdfa/2 to allow adding user-provided --permit-file-read options. Changed Removed unnecessary Ghostscript step to embed fonts. Instead, the relevant arguments are now part of our default set of pdfwrite arguments, and hence are also applied to the PDF concatenation added in 1.5.0. Made PDF concatenation take into account SAFER mode.","ref":"changelog.html#1-6-0-2023-01-12","title":"Changelog - [1.6.0] - 2023-01-12","type":"extras"},{"doc":"Added Add automatic PDF concatenation when passing a list to print_to_pdf/2 or print_to_pdfa/2 . (@xaviRodri) Add warm_up/1 to allow one-off launches of the Chrome executable with our default arguments, to mitigate random CI failures on Github Actions.","ref":"changelog.html#1-5-0-2022-12-22","title":"Changelog - [1.5.0] - 2022-12-22","type":"extras"},{"doc":"Added Add error details on failure to checkout worker from pool. Add a whole list of new default command line options following Puppeteer's example. Changed wait_for and evaluate options can now be combined, as the wait_for script is appended to the user-given evaluate expression. Fixed Make sure to close a browser target when the worker in the pool is terminated. Previously, when a worker was terminated due to an exception (e.g. the timeout error), the target wasn't cleaned up, potentially leading to memory exhaustion. Actually inspect the current state of the protocol in the timeout exception, instead of the (pretty useless) initial parameter. Make sure the inspectorCrashed warning is only printed once.","ref":"changelog.html#1-4-0-2022-12-07","title":"Changelog - [1.4.0] - 2022-12-07","type":"extras"},{"doc":"Changed Included the inspected ChromicPDF.Protocol in the timeout exception to improve debugging. Bump jason to 1.3 Bump telemetry to 1.1 Updated dev dependencies","ref":"changelog.html#1-3-1-2022-11-08","title":"Changelog - [1.3.1] - 2022-11-08","type":"extras"},{"doc":"Added Add disable_scripts global option. (@MaeIsBad) Add error details about potential shared memory exhaustion. (@WilliamVenner)","ref":"changelog.html#1-3-0-2022-09-27","title":"Changelog - [1.3.0] - 2022-09-27","type":"extras"},{"doc":"Fixed Use old pdf interpreter with ghostscript &gt; 9.56 to avoid segfaults (see #158)","ref":"changelog.html#1-2-2-2022-07-18","title":"Changelog - [1.2.2] - 2022-07-18","type":"extras"},{"doc":"Fixed Incompatibility with ghostscript 9.56.1 (fixes #153) Added search paths for chrome executable (fixes #151)","ref":"changelog.html#1-2-1-2022-07-12","title":"Changelog - [1.2.1] - 2022-07-12","type":"extras"},{"doc":"Added Improved docs on header/footer templates saying that external URLs don't work. Added a logger call when we receive the Inspector.targetCrashed message, so users can tell that their Chrome target has died for some reason. Add more paper sizes to ChromicPDF.Template . (@williamthome) Add :landscape option to ChromicPDF.Template . (@williamthome) Add :init_timeout option to ChromicPDF.Browser.SessionPool . (@dvic)","ref":"changelog.html#1-2-0-2022-03-17","title":"Changelog - [1.2.0] - 2022-03-17","type":"extras"},{"doc":"Fixed Documentation updates (@kianmeng)","ref":"changelog.html#1-1-2-2021-10-27","title":"Changelog - [1.1.2] - 2021-10-27","type":"extras"},{"doc":"Added Relaxed telemetry dependency to avoid blocking dependency update (@leandrocp) Add chromium path on macOS when installed via homebrew (@shamanime)","ref":"changelog.html#1-1-1-2021-09-24","title":"Changelog - [1.1.1] - 2021-09-24","type":"extras"},{"doc":"Changed Improved error message when Chrome dies at startup. Improved docs on the no_sandbox option. Added Added chrome_executable option to allow specifying path to chrome executable.","ref":"changelog.html#1-1-0-2021-04-16","title":"Changelog - [1.1.0] - 2021-04-16","type":"extras"},{"doc":"Added Added evaluate option to run client-side scripts before printing. Added a few options ( evaluate , set_cookie , wait_for ) to capture_screenshot/2 . Changed Reimplemented wait_for option based on a JS script and the evaluate option to overcome race condition issues of original solution. Behaviour remains the same.","ref":"changelog.html#1-0-0-2021-03-23","title":"Changelog - [1.0.0] - 2021-03-23","type":"extras"},{"doc":"Fixed Enforced telemetry version 0.4.2 (fixes #108)","ref":"changelog.html#0-7-2-2021-02-26","title":"Changelog - [0.7.2] - 2021-02-26","type":"extras"},{"doc":"Fixed To determine the session pool / ghostscript pool size, if not specified in the options, we now fetch the number of schedulers at runtime, not compile time. Makes more sense. We also set a minimum of 1 in case there is only 1 scheduler online.","ref":"changelog.html#0-7-1-2021-02-08","title":"Changelog - [0.7.1] - 2021-02-08","type":"extras"},{"doc":"Added Added option wait_for to wait for DOM element attribute to be set dynamically. (@jarimatti) New global timeout option for session pool allows to configure timeout of print processes. New global ignore_certificate_errors option allows to bypass SSL certificate verification. New global chrome_args option allows to pass custom flags to chrome command.","ref":"changelog.html#0-7-0-2021-01-25","title":"Changelog - [0.7.0] - 2021-01-25","type":"extras"},{"doc":"Fixed When sending HTML to Chrome with {:html, &lt;content&gt;} , wait for the Page.loadEventFired notification to allow external resources (images, scripts, ...) to be fetched. (#80)","ref":"changelog.html#0-6-2-2020-12-28","title":"Changelog - [0.6.2] - 2020-12-28","type":"extras"},{"doc":"Fixed Reverted to file descriptor redirection to mitigate weird Port behaviour (#76).","ref":"changelog.html#0-6-1-2020-11-17","title":"Changelog - [0.6.1] - 2020-11-17","type":"extras"},{"doc":"Changed Elixir version housekeeping. Fixed a warning on Elixir 1.11 by adding :eex to :extra_applications . ChromicPDF now requires Elixir &gt;= 1.10 for its use of Application.compile_env/3 . Dropped poolboy in favour of nimble_pool . This renders the max_overflow poolboy option without effect. Made &quot;online mode&quot; the default. Chrome will resolve all URL references unless the global option offline: false is set. Added Added telemetry events for the PDF generation &amp; PDF/A conversion. &quot;On Demand&quot; mode allows to start &amp; stop Chrome as needed, much like puppeteer does. This helps in development to prevent leaving behind zombie processes when the BEAM is aborted with Ctrl+C. New global option discard_stderr allows to enable Chrome's stderr logging which is by default piped to /dev/null . Fixed Graceful shutdown is now actually graceful in that it waits for Chrome to clean up the debugging sessions and close the pipe on its end.","ref":"changelog.html#0-6-0-2020-11-16","title":"Changelog - [0.6.0] - 2020-11-16","type":"extras"},{"doc":"Fixed Moved static files required for PDF/A generation to /priv so they are embedded into releases. Moved logo files out of /priv so they are not included in releases.","ref":"changelog.html#0-5-2-2020-07-17","title":"Changelog - [0.5.2] - 2020-07-17","type":"extras"},{"doc":"Fixed Fixed typespecs for Template.source_and_options/1 . [content_option] weren't allowed as call to styles/1 narrowed type to [style_option] . Added missing keys to style_option .","ref":"changelog.html#0-5-1-2020-07-10","title":"Changelog - [0.5.1] - 2020-07-10","type":"extras"},{"doc":"Changed Removed the :width and :height options from Template.styles/1 and Template.source_and_options/1 as it turns out that Chrome does not pay attention to @page dimensions and instead still sets the size of the produced PDF to US letter. Since it does not seem possible to the PDF size in Chrome headless besides using the paperWidth and paperHeight options, moved to a :size option instead that accepts names like :a4 , :us_letter , and tuples of {&lt;width&gt;, &lt;height&gt;} in inches. These are then passed to paperWidth and paperHeight . Ditched the preferCssPageSize option from Template.source_and_options/1 as it did not seem to have any effect. See above. Added Added zoom: 0.75 to both #header and #footer in the template as this seems to be exactly what is needed to reverse the viewport scaling that Chrome uses on them by default. With this, headers &amp; footers and the content can use the same CSS styles. Included -webkit-print-color-adjust: exact rule to template so background-color rules are enabled by default. Fixed Make print_to_pdfa/2 actually accept source_and_options() map from Template .","ref":"changelog.html#0-5-0-2020-07-10","title":"Changelog - [0.5.0] - 2020-07-10","type":"extras"},{"doc":"Added Allow {:url, &lt;path&gt;} input tuples where path is only a path, and not a file:// URL. Changed When passing a function to the :output parameter, the function result will now be returned as part of the print_to_pdf &amp; friends result as {:ok, &lt;callback_result&gt;} instead of :ok .","ref":"changelog.html#0-4-0-2020-07-09","title":"Changelog - [0.4.0] - 2020-07-09","type":"extras"},{"doc":"Added Handle {:safe, iolist()} tuples in API and Template (for content coming from Phoenix.View). Expose Template.html_concat as potentially useful helper. Reset navigation history after each print job to avoid leaking information. Create new empty browser context for each target (similar to incognito tab). Restart browser target after a maximum number of PDFs have been printed to avoid memory bloat. Changed Set user agent to custom string. Default number of sessions in pool to half the number of available cores.","ref":"changelog.html#0-3-1-2020-04-09","title":"Changelog - [0.3.1] - 2020-04-09","type":"extras"},{"doc":"Added HTML source and header and footer template accept iolists now New Template module contains basic CSS skeleton to easily dimension &amp; layout pages (header &amp; footer margins)","ref":"changelog.html#0-3-0-2020-03-30","title":"Changelog - [0.3.0] - 2020-03-30","type":"extras"},{"doc":"Added Add set_cookie option to print_to_pdf/2 . Targets now navigate to about:blank after PDF prints. Fixed the temporary file yielding way of calling print_to_pdf/2 .","ref":"changelog.html#0-2-0-2020-03-06","title":"Changelog - [0.2.0] - 2020-03-06","type":"extras"},{"doc":"Added First release to hex.pm","ref":"changelog.html#0-1-0-2020-03-02","title":"Changelog - [0.1.0] - 2020-03-02","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright [yyyy] [name of copyright owner] Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"License","type":"extras"}]